
file <- file("./data.csv", open="r", encoding="shift-jis")
data <- read.table(file, header=T, sep=",", fill = TRUE)

num = data$fault
time <- seq(0, length(num)-1)

llf <- function(x){
  return(function(par){
    p <- par[1]
    a <- par[2]
    b <- par[3]
    hr <- function(x){
	(p*exp(-(1/a)*x))*(b-(x-1))
	}
	sum(log(hr(time)*num))-sum(hr(time)*num)
    })
}

ans <- optim(par = c(0.001, 10, 2000), fn = llf(num), control=list(fnscale=-1))

p <- ans$par[1]
a <- ans$par[2]
b <- ans$par[3]
n <- length(time)

write (p, file = "./results.csv")
write (a, file = "./results.csv", append = T)
write (b, file = "./results.csv", append = T)
write (n, file = "./results.csv", append = T)
